<?php

/**
 * @file
 * Popup für das Anlegen von Sip Einträgen
 */

chdir("..");

include "./includes/variables.php";
include "./misc/database.php";
$ba= new beroAri();
require_once ('./includes/lang.php');
include("./misc/config_parameter.php");

$page=$_GET['start'];

$name='"general"';
$query_comp=$ba->select("SELECT * FROM sip");
while ($entry = $ba->fetch_array($query_comp)) {
    if ($entry['id']!=$_GET['id'])
	$name.=','.'"'.$entry['name'].'"';
        
}
?>


<script type="text/javascript">
$("#sipp").validate({

rules: {

name: {
    required : true ,
    specChar: true,
    checkBlank: true,
    compareName: [<?php echo $name; ?>]
},
user: "specChar",
displayname: "specChar",
auth_user: "specChar",
secret: "specChar",
sip_from_user_setting_manual:{
    specChar: "#sip_from_user_setting_manual:visible",
},
sip_from_display_setting_manual:{
    specChar: "#sip_from_display_setting_manual:visible",
},
server_address: {
    checkHostname:true,
    required: true,
    sipPortCheck: "<?php echo udpports(); ?>"
},
regrefresh : {
    required : "#regrefresh:visible",
    range : [30,86400]
}
}
}); 

$("#stunradio").click(function() {
    $(".options").show();
    $(".stun").show();
    $(".externip").hide();
});
$("#externipradio").click(function() {
    $(".options").show();
    $(".externip").show();
    $(".stun").hide();
});

function move(Orig, Dest){
	var varFromBox = document.getElementById(Orig);
	var varToBox = document.getElementById(Dest);
	if ((varFromBox != null) && (varToBox != null))
	{
		if(varFromBox.length < 1)
		{
			alert('There are no items in the source ListBox');
			return false;
		}
		if(varFromBox.options.selectedIndex == -1) // when no Item is selected the index will be -1

		{
			alert('Please select an Item to move');
			return false;
		}
		while ( varFromBox.options.selectedIndex >= 0 )
		{
			var newOption = new Option(); // Create a new instance of ListItem

			newOption.text = varFromBox.options[varFromBox.options.selectedIndex].text;
			newOption.value = varFromBox.options[varFromBox.options.selectedIndex].value;
			varToBox.options[varToBox.length] = newOption; //Append the item in Target Listbox

			varFromBox.remove(varFromBox.options.selectedIndex); //Remove the item from Source Listbox

		}
	}
	return false;
}
function selectall(){
	selectBox = document.getElementById('sel');
	for (var i = 0; i < selectBox.options.length; i++) {
		selectBox.options[i].selected = true;
	}
}
function up() {
	obj=document.getElementById('sel');
	for (var i = 0; i < obj.options.length; i++)
		if (obj.options[ i ].selected){
			if (i>0) change(obj,i,i-1);
		}

}

function down() {
	obj=document.getElementById('sel');
	for (var i = obj.options.length-1; i >= 0; i--){
		if (obj.options[ i ].selected){
			if ( i<obj.length-1) change(obj,i,i+1);
		}
	}
}
function change(obj,num1,num2) {
	proVal=obj.options[num1].value;
	proTex=obj.options[num1].text;
	obj.options[num1].value=obj.options[num2].value;
	obj.options[num1].text=obj.options[num2].text;
	obj.options[num2].value=proVal;
	obj.options[num2].text=proTex;
	obj.options[num2].selected=true;
	obj.options[num1].selected=false;
}
function hidec(){
	var config_sip=document.getElementById('config_sip');
	config_sip.style.display="none";
}

function show_config(){
	var config_sip=document.getElementById('config_sip');
	if (config_sip.style.display=="none"){
		config_sip.style.display="";
	}else{
		config_sip.style.display="none";
	}
}
function hide_reg(value){
	if (value==false){
		document.getElementById('reg').style.display="none";
		document.getElementById('reg_option').style.display="none";
		document.getElementById('hard_reregister').style.display="none";
	}else{
		document.getElementById('reg').style.display="";
		document.getElementById('reg_option').style.display="";
		document.getElementById('hard_reregister').style.display="";
	}
}
function options(stun, externip){
	if (stun==false && externip==false){
		$(".options").hide();
	}else{
		$(".options").show();
        }
        if (stun==true){
            $(".stun").show();
            $(".externip").hide();
        }else{
            $(".stun").hide();
        }
        if (externip==true){
            $(".externip").show();
            $(".stun").hide();
        }else{
            $(".externip").hide();
        }
}

function change_config(reg){
	if (reg.checked){
		document.getElementById("sip_from_user_setting").options[4].selected=true; document.getElementById("sip_from_user_setting_manual").style.display="none";
		document.getElementById("sip_from_display_setting").options[0].selected=true; document.getElementById("sip_from_display_setting_manual").style.display="none";
		document.getElementById("from_sip_src_setting").options[1].selected=true;
	}else{
		document.getElementById("sip_from_user_setting").options[0].selected=true; document.getElementById("sip_from_user_setting_manual").style.display="none";
		document.getElementById("sip_from_display_setting").options[0].selected=true; document.getElementById("sip_from_display_setting_manual").style.display="none";
		document.getElementById("from_sip_src_setting").options[0].selected=true;
	}
}

</script>

<center>
<?php

require_once "./includes/isgwtelnet.php";

/*
 * Die Udpports, die in der Datenbank gespeichert sind werden zurückgegeben
 * und nachher angezeigt.
 */

function udpports() {
    $ba = new beroAri();
    $query = $ba->select("select udpports from sip_general");
    while ($entry = $ba->fetch_array($query)) {
        return $entry['udpports'];
    }
}

function showdefmc($config_values){
	$isgw = new isgwtelnet();
	$result=$isgw->isgw_login();
	if ($result!=false){
		$dialplanc=$isgw->isgw_dialplanconfig();
		$zeilen=split("\n",$dialplanc);
		foreach ($zeilen as $zeile){
			if (stripos($zeile,'[')===0){
				preg_match("/\[(?<bez>.+)\]\[(?<name>.+)\][\s]*(?<desc>.+)[\s]*\<(?<val>.*)\>[\s]*'(?<def>.*)'/",$zeile,$res);
				if (!in_array($res['name'],$config_values) && $res['bez']=="s")
					echo "<script>
							var extra_tooltip=document.getElementById('extra_tooltip');
							extra_tooltip.innerHTML=extra_tooltip.innerHTML+'<p>".DIALPLAN_OPTION_DIS."<b>&nbsp;".$res['name']."</b><br>".DIALPLAN_VALUES_DIS."<b>&nbsp;&lt;".$res['val']."&gt;</b><br><i>".$res['desc']."</i></p><br>';
						</script>";
			}
		}
		$ba=new beroAri();
		$query=$ba->select("select config from sip where id='".$_GET['id']."'");
		while  ($entry = $ba->fetch_array($query)) {
			$config=$entry['config'];
		}
		if ($config!=""){
			$configs=split(',',$config);
			foreach ($configs as $value){
				$key=explode('=',$value,2);
				if ($key[0]!="" && $key[1]!="" && !in_array($key[0],$config_values)) {
					echo "<script>var addit_options=document.getElementById('addit_options');
							if (addit_options.innerHTML=='')
								addit_options.innerHTML='".$key[0]."=".$key[1]."';
							else
								addit_options.innerHTML=addit_options.innerHTML+'\\n".$key[0]."=".$key[1]."';</script>";
				}elseif ($key[0]!="" && $key[1]=="" && !in_array($key[0],$config_values)){
					echo "<script>var addit_options=document.getElementById('addit_options');
							if (addit_options.innerHTML=='')
								addit_options.innerHTML='".$key[0]."=';
							else
								addit_options.innerHTML=addit_options.innerHTML+'\\n".$key[0]."=';</script>";
				}
			}
		}
	}
}

function show_confadd($config_values){
	$isgw = new isgwtelnet();
	$result=$isgw->isgw_login();
	if ($result!=false){
		$dialplanc=$isgw->isgw_dialplanconfig();
		$zeilen=split("\n",$dialplanc);
		foreach ($zeilen as $zeile){
			if (stripos($zeile,'[')===0){
				preg_match("/\[(?<bez>.+)\]\[(?<name>.+)\][\s]*(?<desc>.+)[\s]*\<(?<val>.*)\>[\s]*'(?<def>.*)'/",$zeile,$res);
				if (!in_array($res['name'],$config_values) && $res['bez']=="s")
					echo "<script>
							var extra_tooltip=document.getElementById('extra_tooltip');
							extra_tooltip.innerHTML=extra_tooltip.innerHTML+'<p>".DIALPLAN_OPTION_DIS."<b>&nbsp;".$res['name']."</b><br>".DIALPLAN_VALUES_DIS."<b>&nbsp;&lt;".$res['val']."&gt;</b><br><i>".$res['desc']."</i></p><br>';
							var addit_options=document.getElementById('addit_options');
							if (addit_options.innerHTML=='')
								addit_options.innerHTML='".$res['name']."=".$res['def']."';
							else
								addit_options.innerHTML=addit_options.innerHTML+'\\n".$res['name']."=".$res['def']."';
						</script>";
			}
		}
	}
}

function type($ba,$id){
	$type=getValue($ba,$id,"type");
	if ($type=="1")
		$checkbox="<input type='hidden' name='register' value='0'><input type='checkbox' name='register' id='register' value='1' checked onchange='hide_reg(this.checked); change_config(this)'>";
	else
		$checkbox="<input type='hidden' name='register' value='0'><input type='checkbox' name='register' id='register' value='1' onchange='hide_reg(this.checked); change_config(this)'>";
	return $checkbox;
}

function hard_reregister($ba,$id){
	$hard_reregister=getValue($ba,$id,"hard_reregister");
	if ($hard_reregister=="1")
		$checkbox="<input type='hidden' name='hard_reregister' value='0'><input type='checkbox' name='hard_reregister' value='1' checked>";
	else
		$checkbox="<input type='hidden' name='hard_reregister' value='0'><input type='checkbox' name='hard_reregister' value='1'>";
	return $checkbox;
}

function register_option($ba,$id){
	$option=getValue($ba,$id,"register_option");
	if ($option=="validate")
		return "<option value='validate' selected>validate</option>
			<option value='no-validate no-options-keepalive'>no-validate</option>";
	elseif ($option=="no-validate no-options-keepalive" || $option=="")
		return "<option value='validate'>validate</option>
			<option value='no-validate no-options-keepalive' selected>no-validate</option>";
	else return "<option value='validate'>validate</option>
			<option value='no-validate no-options-keepalive' selected>no-validate</option>";
}


function sip_transport($option){
    $sel="<select name='sip_transport' id='sip_transport'>";
    if ($option=="udp") $sel.="<option value='udp' selected>udp</option>";
    else $sel.="<option value='udp'>udp</option>";
    if ($option=="tcp") $sel.="<option value='tcp' selected>tcp</option>";
    else $sel.="<option value='tcp'>tcp</option>";
    if ($option=="tls") $sel.="<option value='tls' selected>tls</option>";
    else $sel.="<option value='tls'>tls</option>";
    $sel.="</select>";
    return $sel;
}

function getValue($ba,$id,$option){
	$query=$ba->select("select $option from sip where id=\"$id\"");
	return stripslashes(sqlite_fetch_single($query));
}


$config_values=array("t38","dtmfmode","codecs","ie_on_sip","from_sip_src_setting",
					"wait_for_cancel","sip_from_user_setting",
					"sip_from_display_setting","failover_proxy","failover_timeout","s2i_cpt","i2s_cpt");
(getValue($ba,$_GET['id'],"stunserver")=="") ? $stun="" : $stun="checked";
(getValue($ba,$_GET['id'],"externip")=="") ? $externip="" : $externip="checked";


	echo ("<form class='extensions_form' name='sipp' id='sipp' action='misc/sip_submit.php' method='POST'>
			<input type=hidden name='start' value=" . $page . ">
			<table border=0 class='contenttoc'>
			<tr onmouseover=\"Tip('".TRUNKS_SIP_NAME."')\" onmouseout='UnTip()'>
			<td><b>".SIP_NAME_DIS.":</b>&nbsp;</td>
			<td><input name='name' id='name' type='text' value='".getValue($ba,$_GET['id'],"name")."'></td>
			</tr>
			<tr onmouseover=\"Tip('".TRUNKS_SIP_SERVER_ADDRESS."')\" onmouseout='UnTip()'>
			<td><b>".SIP_SERVER_ADDRESS_DIS.":</b>&nbsp;</td>
			<td><input name='server_address' id='server_address' type='text' value='".getValue($ba,$_GET['id'],"server_address")."'></td>
			</tr>
			<tr onmouseover=\"Tip('".TRUNKS_SIP_USER."')\" onmouseout='UnTip()'>
			<td><b>".SIP_USER_DIS.":</b>&nbsp;</td>
			<td><input name='user' id='user' type='text' value='".getValue($ba,$_GET['id'],"user")."'></td>
			</tr>
			<tr>
			<td><b>".SIP_AUTH_USER_DIS.":</b>&nbsp;</td>
			<td><input name='auth_user' type='text' value='".getValue($ba,$_GET['id'],"auth_user")."'></td>
			</tr>
			<tr>
			<td><b>".SIP_DISPLAYNAME_DIS.":</b>&nbsp;</td>
			<td><input name='displayname' type='text' value='".getValue($ba,$_GET['id'],"displayname")."'></td>
			</tr>
			<tr onmouseover=\"Tip('".TRUNKS_SIP_SECRET."')\" onmouseout='UnTip()'>
			<td><b>".SIP_SECRET_DIS.":</b>&nbsp;</td>
			<td><input name='secret' id='secret' type='text' value='".getValue($ba,$_GET['id'],"secret")."'></td>
			</tr>
                        <tr>
			<td><b>".SIP_GENERAL_SIP_TRANSPORT_DIS.":</b></td>
			<td>".sip_transport(getValue($ba,$_GET['id'],"sip_transport"))."</td>
			</tr>
			<tr>
			<td><b>".SIP_OPTIONS_DIS.":</b>&nbsp;</td>
			<td><div><input name='option' id='stunradio' type='radio' value='stun' ".$stun." >".SIP_STUNSERVER_DIS."</div>
                        <div><input name='option' id='externipradio' type='radio' value='externip' ".$externip.">".SIP_EXTERNIP_DIS."</div></td>
			</tr>
			<tr class='options'>
			<td><div class='stun'><b>".SIP_STUNSERVER_DIS.":</b>&nbsp;</div> 
                            <div class='externip'><b>".SIP_EXTERNIP_DIS.":</b>&nbsp;</div></td>
			<td><div class='stun'><input name='stunserver' id='stunserver' type='text' value='".getValue($ba,$_GET['id'],"stunserver")."' ></div>
                            <div class='externip'><input name='externip' id='externip' type='text' value='".getValue($ba,$_GET['id'],"externip")."'></div></td>
			</tr>
			<tr onmouseover=\"Tip('".TRUNKS_SIP_REGISTER."')\" onmouseout='UnTip()'>
			<td><b>".SIP_REGISTER_DIS.":</b>&nbsp;</td>
			<td>".type($ba,$_GET['id'])."</td>
			</tr>
			<tr id='reg' onmouseover=\"Tip('".TRUNKS_SIP_REGREFRESH."')\" onmouseout='UnTip()'>
			<td><b>".SIP_REGISTRATION_INTERVALL_DIS.":</b></td>");
                        if (getValue($ba,$_GET['id'],"regrefresh")=="")  $regrefresh="300"; else $regrefresh=getValue($ba,$_GET['id'],"regrefresh");
		echo ("<td><input name='regrefresh' id='regrefresh' type='text' value='". $regrefresh ."'></td>
			</tr>
			<tr id='reg_option' onmouseover=\"Tip('".TRUNKS_SIP_REGISTER_OPTION."')\" onmouseout='UnTip()'>
			<td><b>".SIP_REGISTER_OPTION_DIS.":</b></td>
			<td>
			<select name='register_option' onmouseover=\"Tip('".TRUNKS_SIP_REGISTER_OPTION."')\" onmouseout='UnTip()'>".register_option($ba,$_GET['id'])."</select></td>
			</tr>
			<tr id='hard_reregister'>
			<td><b>".SIP_HARD_REREGISTER_DIS.":</b></td>
			<td>".hard_reregister($ba,$_GET['id'])."</td>
			</tr>
			<tr>
			<td align='center' colspan='2'><a href='#' onclick='show_config();'>".SIP_MORE_DIS."...</a></td>
			</tr>
			</table>
			<br/>
                                <table id='config_sip' class='contenttoc'>
					<tr><td colspan='2' align='center'><b>".DIALPLAN_CONFIGURATION_DIS."</b></td></tr>
					<tr onmouseover=\"Tip('".T38."')\" onmouseout='UnTip()' id='t38_tr'>
						<td><b>".DIALPLAN_T38_SUPPORT_DIS."</b></td>
		    			<td>".t38()."</td>
					</tr>
					<tr onmouseover=\"Tip('".DTMFMODE."')\" onmouseout='UnTip()' id='dtmf_tr'>
						<td><b>".DIALPLAN_DTMF_MODE_DIS."</b></td>
		    			<td>".dtmfmode()."</td>
					</tr>
					<tr onmouseover=\"Tip('".IE_ON_SIP."')\" onmouseout='UnTip()' id='ie_on_sip_tr'>
						<td><b>".DIALPLAN_IE_ON_SIP_DIS."</b></td>
		    			<td>".ie_on_sip()."</td>
					</tr>
					<tr id='codecs_tr'>
						<td><b>".DIALPLAN_CODECS_DIS."</b></td>
		    			<td>".codecs()."</td>
   		    		</tr>
					<tr onmouseover=\"Tip('".WAIT_FOR_CANCEL."')\" onmouseout='UnTip()' id='wait_for_cancel_tr'>
						<td><b>".DIALPLAN_WAIT_FOR_CANCEL_DIS."</b></td>
		    			<td>".wait_for_cancel()."</td>
					</tr>
					<tr onmouseover=\"Tip('".CALL_PROGRESS_TABLE."')\" onmouseout='UnTip()' id='s2i_cpt_tr'>
						<td><b>".DIALPLAN_CALL_PROGRESS_TABLE_S2I_DIS."</b></td>
		    			<td>".s2i_cpt()."</td>
					</tr>
					<tr onmouseover=\"Tip('".CALL_PROGRESS_TABLE."')\" onmouseout='UnTip()' id='s2i_cpt_tr'>
						<td><b>".DIALPLAN_CALL_PROGRESS_TABLE_I2S_DIS."</b></td>
		    			<td>".i2s_cpt()."</td>
					</tr>
					<tr onmouseover=\"Tip('".FAILOVER_ACCOUNT."')\" onmouseout='UnTip()' id='failover_proxy_tr'>
						<td><b>".DIALPLAN_FAILOVER_ACCOUNT_DIS."</b></td>
						<td>".failover_proxy()."</td>
					</tr>
					<tr onmouseover=\"Tip('".FAILOVER_TIMEOUT."')\" onmouseout='UnTip()' id='failover_timeout_tr'>
						<td><b>".DIALPLAN_FAILOVER_TIMEOUT_DIS."</b></td>
						<td>".failover_timeout()."</td>
					</tr>
					<tr onmouseover=\"Tip('".FROM_SIP_SRC_SETTING."')\" onmouseout='UnTip()' id='sip_src_setting_tr'>
						<td><b>".DIALPLAN_FROM_SIP_SRC_SETTING_DIS."</b></td>
						<td>".from_sip_src_setting()."</td>
					</tr>
					<tr>
						<td colspan='2'>&nbsp;</td>
					</tr>
					<tr>
						<th colspan='2'>".DIALPLAN_CALLER_ID_MAPPING_DIS."</th>
					</tr>
					<tr onmouseover=\"Tip('".SIP_FROM_USER_SETTING."')\" onmouseout='UnTip()' id='sip_from_user_setting_tr'>
						<td><b>".DIALPLAN_SIP_FROM_USER_SETTING_DIS."</b></td>
						<td>".caller_id_mapping_sip('sip_from_user_setting')."</td>
					</tr>
					<tr onmouseover=\"Tip('".SIP_FROM_DISPLAY_SETTING."')\" onmouseout='UnTip()' id='sip_from_display_setting_tr'>
						<td><b>".DIALPLAN_SIP_FROM_DISPLAY_SETTING_DIS."</b></td>
						<td>".caller_id_mapping_sip('sip_from_display_setting')."</td>
					</tr>

					<tr>
						<td colspan='2'>&nbsp;</td>
					</tr>
					<tr onmouseover=\"Tip('".ADDIT_OPTIONS."')\" onmouseout='UnTip()'>
						<td colspan='2'><b>".DIALPLAN_ADDITIONAL_CONFIG_DIS."</b></td>
					</tr>
					<tr onmouseover=\"Tip('".ADDIT_OPTIONS."')\" onmouseout='UnTip()'>
						<td colspan='2'><textarea name='addit_options' id='addit_options' rows='4' style='width:305px;'></textarea></td>
					</tr>
					<tr>
						<td colspan='2'>
						<br>
						<b>".DIALPLAN_ADDITIONAL_CONFIG_DOC_DIS."</b>
						</td>
					</tr>
					<tr>
						<td colspan='2'>
						<p id='extra_tooltip' style='text-align:left; height: 150px; width:305px; overflow: auto; border: 1px solid #A31D26; background: none repeat scroll 0% 0% rgb(238, 238, 238); color: rgb(0, 0, 0);'>
						</td>
					</tr>
					</table><br>");
			if (isset($_GET['id'])){
				showdefmc($config_values);
			}else{
				show_confadd($config_values);
			}
			if (isset($_GET['id']))	echo ("<input type='hidden' name='alt_name' value='".getValue($ba,$_GET['id'],"name")."'><input type='hidden' name='id_upd' value='". $_GET['id']."'>");
			echo ("<div class='center'><input name='submit' type='submit' value='".BUTTON_SAVE."' onclick='selectall();' onmouseover=\"Tip('".TRUNKS_SIP_SAVE."')\" onmouseout='UnTip()'>
			 &nbsp;&nbsp;<input name='close' type='button' value='".BUTTON_CLOSE."' onclick='javascript:$(\"#dialog\").dialog(\"close\");' onmouseover=\"Tip('".POPUPS_BUTTON_CLOSE."')\" onmouseout='UnTip()'></div>
			</form>");

?>
</center>

