<?php
//Überprüfung on die SESSION noch gültig ist
@session_start();
if (!isset($_SESSION['beroari_time'])){
	 echo "<script>window.location='../index.php?m=sip'</script>";
}elseif((isset($_SESSION['beroari_time']))&&(($_SESSION['beroari_time']+1200)<time())){
	@session_unset();
	@session_destroy();
	echo "<script>window.location='../index.php?m=sip'</script>";
}else{
	$_SESSION['beroari_time']=time();

	chdir("..");

	include "./includes/variables.php";
        include "./includes/Helper.php";
	include "./misc/database.php";
	require_once "./includes/isgwtelnet.php";
	$ba= new beroAri();
	require_once("./includes/lang.php");

	function parameters($config=""){
		foreach ($_POST as $key=>$value){
			$_POST[$key]=str_replace("'","\"",$_POST[$key]);
		}

			//T.38
			if (isset($_POST['t38']) && $config!=""){
				$config.=",t38=1";
			}elseif(isset($_POST['t38']) && $config==""){
				$config.="t38=1";
			}elseif(!isset($_POST['t38']) && $config!=""){
				$config.=",t38=0";
			}elseif(!isset($_POST['t38']) && $config==""){
				$config.="t38=0";
			}



			//IE on SIP
			if (isset($_POST['ie_on_sip'])){
				$config.=",ie_on_sip=1";
			}elseif(!isset($_POST['ie_on_sip'])){
				$config.=",ie_on_sip=0";
			}


			//WAIT FOR CANCEL
			if (isset($_POST['wait_for_cancel'])){
				$config.=",wait_for_cancel=1";
			}elseif(!isset($_POST['wait_for_cancel'])){
				$config.=",wait_for_cancel=0";
			}


			//DTMF
			if (isset($_POST['dtmfmode'])) $config.=",dtmfmode=".$_POST['dtmfmode'];

			//S2I CPT
			if (isset($_POST['s2i_cpt'])) $config.=",s2i_cpt=".$_POST['s2i_cpt'];
			//I2S CPT
			if (isset($_POST['i2s_cpt'])) $config.=",i2s_cpt=".$_POST['i2s_cpt'];

			//FAILOVER_PROXY
			if (isset($_POST['failover_proxy'])) $config.=",failover_proxy=".$_POST['failover_proxy'];

			//FAILOVER_PROXY
			if (isset($_POST['failover_timeout'])) $config.=",failover_timeout=".$_POST['failover_timeout'];

			//SIP_SRC_SETTING
			if (isset($_POST['from_sip_src_setting'])) $config.=",from_sip_src_setting=".$_POST['from_sip_src_setting'];

			//SIP_FROM_USER_SETTING
			if (isset($_POST['sip_from_user_setting']) && $_POST['sip_from_user_setting']!='manual') $config.=",sip_from_user_setting=".$_POST['sip_from_user_setting'];
			else if (isset($_POST['sip_from_user_setting']) && $_POST['sip_from_user_setting']=='manual') $config.=",sip_from_user_setting=".$_POST['sip_from_user_setting_manual'];

			//SIP_FROM_DISPLAY_SETTING
			if (isset($_POST['sip_from_display_setting']) && $_POST['sip_from_display_setting']!='manual') $config.=",sip_from_display_setting=".$_POST['sip_from_display_setting'];
			else if (isset($_POST['sip_from_display_setting']) && $_POST['sip_from_display_setting']=='manual') $config.=",sip_from_display_setting=".$_POST['sip_from_display_setting_manual'];

			//CODECS
			$c="";
			for ($i=0;$i<count($_POST['codecs']);$i++){
				if ($c!="") $c.=":";
				$c.= $_POST['codecs'][$i];
			}
			if ($c!="")	$config.=",codecs=".$c;


			//Additional config string hinzufügen.
			if ($_POST['addit_options']!="") $config.=",".str_replace(array("\r\n", "\n", "\r"),",",$_POST['addit_options']);

			return $config;
	}

	if ($_POST['id_upd']){
		if ($ba->is_error()){
			die($ba->error());
		}
		if (strtolower($_POST['name'])=="general"){
			echo "<script>alert('".SIP_INVALID_NAME_DIS."'); window.history.back();</script>";
					return;
		}
		$query_comp=$ba->select("SELECT * FROM sip");
		while ($entry = $ba->fetch_array($query_comp)) {
			if ($_POST['id_upd']!=$entry['id']){
				if ($_POST['name']==$entry['name']){
					echo "<script>alert('".SIP_INVALID_NAME_DIS."'); window.history.back(); </script>";
					return;
				}
			}
		}
		$name=$_POST['name'];
		$ser_addr=$_POST['server_address'];
		$user=  sqlite_escape_string($_POST['user']);
		$auth_user=  sqlite_escape_string($_POST['auth_user']);
		$displayname=  sqlite_escape_string($_POST['displayname']);
		$secret= sqlite_escape_string($_POST['secret']);
                $sip_transport=$_POST['sip_transport'];
		$type=$_POST['register'];
                if ($_POST['option']=="stun") $stunserver=$_POST['stunserver'];
		if ($type==1) {
			$regrefresh=$_POST['regrefresh'];
			$register_option=$_POST['register_option'];
			$hard_reregister=$_POST['hard_reregister'];
		}else{
			$regrefresh="";
			$register_option="no-validate no-options-keepalive";
			$hard_reregister="0";
		}
		if ($_POST['option']=="externip") $externip=$_POST['externip'];
		$config=parameters();
		$id=$_POST['id_upd'];
		$query_new = $ba->update("UPDATE sip SET name='".sqlite_escape_string ($name)."', sip_transport='".sqlite_escape_string ($sip_transport)."', server_address='".sqlite_escape_string ($ser_addr)."',
						 user='".sqlite_escape_string ($user)."', auth_user='".sqlite_escape_string ($auth_user)."', displayname='".sqlite_escape_string ($displayname)."', secret='".sqlite_escape_string ($secret)."', type='".sqlite_escape_string ($type)."', regrefresh='".sqlite_escape_string ($regrefresh)."',
						 register_option='".sqlite_escape_string ($register_option)."', config='".sqlite_escape_string ($config)."', hard_reregister='".sqlite_escape_string ($hard_reregister)."', stunserver='".sqlite_escape_string ($stunserver)."',
						 externip='".sqlite_escape_string ($externip)."' WHERE id='$id'");
		if (!$ba->is_error()){
			$query=$ba->update("UPDATE dialplan SET fromId='p:".sqlite_escape_string ($name)."'
						where fromDirection='sip' and fromId='p:".sqlite_escape_string ($_POST['alt_name'])."'");
			$query=$ba->update("UPDATE dialplan SET toId='p:".sqlite_escape_string ($name)."'
						where toDirection='sip' and toId='p:".sqlite_escape_string ($_POST['alt_name'])."'");
			$query=$ba->update("UPDATE dialplan SET fromId='d:".sqlite_escape_string ($name)."'
						where fromDirection='sip' and fromId='d:".sqlite_escape_string ($_POST['alt_name'])."'");
		}
		Helper::activate(1);
		if (!$ba->is_error()){
			echo "<script>window.location='../index.php?m=sip'</script>";

		}else{
			echo "<script>alert('".$ba->error()."');</script>";
		}
	}else{
		if (($_POST['name'])&&($_POST['server_address']))
		{
			if ($ba->is_error()){
				die($ba->error());
			}
			if (strtolower($_POST['name'])=="general"){
				echo "<script>alert('".SIP_INVALID_NAME_DIS."'); window.history.back();</script>";
				return;
			}
			$query_comp=$ba->select("SELECT name FROM sip");
			while ($entry = $ba->fetch_array($query_comp)) {
				if ($_POST['name']==$entry['name']){
					echo "<script>alert('".SIP_INVALID_NAME_DIS."'); window.history.back(); </script>";
					return;
				}
			}
			$name=$_POST['name'];
			$ser_addr=$_POST['server_address'];
			$user=sqlite_escape_string($_POST['user']);
                        $auth_user=  sqlite_escape_string($_POST['auth_user']);
                        $displayname=  sqlite_escape_string($_POST['displayname']);
			$secret=sqlite_escape_string($_POST['secret']);
                        $sip_transport=$_POST['sip_transport'];
			$type=$_POST['register'];
			if ($type==1){
				$regrefresh=$_POST['regrefresh'];
				$register_option=$_POST['register_option'];
				$hard_reregister=$_POST['hard_reregister'];
			}else{
				$regrefresh="";
				$register_option="no-validate no-options-keepalive";
				$hard_reregister="0";
			}
			if ($_POST['option']=="stun") $stunserver=$_POST['stunserver'];
			if ($_POST['option']=="externip") $externip=$_POST['externip'];
			$config=parameters();
			$query_new = $ba->insert_("INSERT INTO sip (name, sip_transport, server_address, user, auth_user, displayname, secret, type,  config,externip,stunserver,regrefresh,register_option,hard_reregister)
									VALUES ('".sqlite_escape_string ($name)."', '".sqlite_escape_string ($sip_transport)."', '".sqlite_escape_string ($ser_addr)."', '".sqlite_escape_string ($user)."', '".sqlite_escape_string ($auth_user)."', '".sqlite_escape_string ($displayname)."', '".sqlite_escape_string ($secret)."', '".sqlite_escape_string ($type)."','".sqlite_escape_string ($config)."','".sqlite_escape_string ($externip)."','".sqlite_escape_string ($stunserver)."','".sqlite_escape_string ($regrefresh)."','".sqlite_escape_string ($register_option)."','".sqlite_escape_string ($hard_reregister)."')");
			Helper::activate(1);
			if (!$ba->is_error()){
				echo "<script>window.location='../index.php?m=sip&start=" . $page . "'</script>";

			}else{
				echo "<script>alert('".$ba->error()."');</script>";
			}

		}else if ($_POST['submit']=="Save"){
			echo "<script> alert('You must fill all the fields'); window.history.back();</script>";
		}
	}
}

?>
